/*
 * Copyright 2015 - 2022 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#pragma once

#if __has_include(<cassert>)
#include <cassert>
#else
#define	assert(e) while (1);
#endif

#include "def.hpp"
#include "defines.hpp"
#include "error.hpp"

namespace ox {

void assertFunc(const char *file, int line, bool pass, const char *assertTxt, const char *msg) noexcept;

void assertFunc(const char *file, int line, const Error &err, const char *assertTxt, const char *msg) noexcept;

void panic([[maybe_unused]]const char *file, [[maybe_unused]]int line, [[maybe_unused]]const char *msg, [[maybe_unused]]const Error &err = OxError(0)) noexcept;

}
